update 2025-03-14 00:27:22

This commit is contained in:
kenzok8 2025-03-14 00:27:22 +08:00
parent f634446c1c
commit 4ba55f53bc
8 changed files with 175 additions and 34 deletions

View File

@ -167,7 +167,8 @@ const preset_outbound = {
['REJECT'],
['REJECT-DROP'],
['PASS'],
['COMPATIBLE']
['COMPATIBLE'],
['GLOBAL']
],
direct: [
['', _('null')],
@ -464,8 +465,10 @@ const CBIHandleImport = baseclass.extend(/** @lends hm.HandleImport.prototype */
if (isEmpty(cfg))
return null;
cfg.hm_id = this.calcID(field, name ?? cfg.name);
cfg.hm_label = '%s %s'.format(name ?? cfg.name, _('(Imported)'));
if (typeof cfg === 'object') {
cfg.hm_id = this.calcID(field, name ?? cfg.name);
cfg.hm_label = '%s %s'.format(name ?? cfg.name, _('(Imported)'));
}
return cfg;
},

View File

@ -221,6 +221,100 @@ class RulesEntry {
}
}
function parseRules(rule) {
// parse rules
// https://github.com/muink/mihomo/blob/8e6eb70e714d44f26ba407adbd7b255762f48b97/config/config.go#L1040-L1090
// https://github.com/muink/mihomo/blob/8e6eb70e714d44f26ba407adbd7b255762f48b97/rules/parser.go#L12
rule = rule.split(',');
let ruleName = rule[0].toUpperCase(),
logical_payload,
payload,
target,
params = [],
subrule;
let l = rule.length;
if (ruleName === 'SUB-RULE') {
subrule = rule.slice(1).join(',').match(/^\((.*)\)/); // SUB-RULE,(payload),subrule
if (subrule) {
[rule, subrule] = [subrule[1].split(',').concat('DIRECT'), rule.pop()];
ruleName = rule[0].toUpperCase();
l = rule.length;
} else
return null;
}
if (hm.rules_logical_type.map(o => o[0]).includes(ruleName)) {
target = rule.pop();
logical_payload = rule.slice(1).join(',').match(/^\(\((.*)\)\)$/); // LOGIC_TYPE,((payload1),(payload2))
if (logical_payload)
logical_payload = logical_payload[1].split('),(');
else
return null;
} else if (hm.rules_type.map(o => o[0]).includes(ruleName)) {
if (l < 2) return null; // error: format invalid
else if (ruleName === 'MATCH') l = 2;
else if (l >= 3) {
l = 3;
payload = rule[1];
}
target = rule[l-1];
params = rule.slice(l);
} else
return null;
// make entry
let entry = new RulesEntry();
entry.type = ruleName;
// parse payload
if (logical_payload)
for (let i=0; i < logical_payload.length; i++) {
let type, factor, deny;
// deny
deny = logical_payload[i].match(/^NOT,\(\((.*)\)\)$/);
if (deny)
[type, factor] = deny[1].split(',');
else
[type, factor] = logical_payload[i].split(',');
if (type === 'RULE-SET')
factor = this.calcID(hm.glossary["ruleset"].field, factor);
entry.setPayload(i, {type: type.toUpperCase(), factor: factor, deny: deny ? true : null});
}
else if (payload)
if (ruleName === 'RULE-SET')
entry.setPayload(0, {factor: this.calcID(hm.glossary["ruleset"].field, payload)});
else
entry.setPayload(0, {factor: payload});
params.forEach((param) => entry.setParam(param, true));
if (subrule)
entry.subrule = subrule;
else
entry.detour = hm.preset_outbound.full.map(([key, label]) => key).includes(target) ? target : this.calcID(hm.glossary["proxy_group"].field, target);
return entry.toString('json');
}
function parseRulesYaml(field, name, cfg) {
let id = this.calcID(field, cfg);
let entry = parseRules.call(this, cfg);
if (!entry)
return null;
// key mapping
let config = {
id: id,
label: '%s %s'.format(id.slice(0,7), _('(Imported)')),
entry: entry
};
return config;
}
function boolToFlag(boolean) {
if (typeof(boolean) !== 'boolean')
return null;
@ -516,8 +610,8 @@ function renderRules(s, uciconfig) {
}
o.validate = function(section_id, value) {
// params only available for types other than
// https://github.com/muink/mihomo/blob/43f21c0b412b7a8701fe7a2ea6510c5b985a53d6/config/config.go#L1050
// https://github.com/muink/mihomo/blob/43f21c0b412b7a8701fe7a2ea6510c5b985a53d6/rules/parser.go#L12
// https://github.com/muink/mihomo/blob/8e6eb70e714d44f26ba407adbd7b255762f48b97/config/config.go#L1050
// https://github.com/muink/mihomo/blob/8e6eb70e714d44f26ba407adbd7b255762f48b97/rules/parser.go#L12
if (['GEOIP', 'IP-ASN', 'IP-CIDR', 'IP-CIDR6', 'IP-SUFFIX', 'RULE-SET'].includes(value)) {
['no-resolve', 'src'].forEach((opt) => {
let UIEl = this.section.getUIElement(section_id, opt);
@ -938,6 +1032,56 @@ return view.extend({
ss.hm_prefmt = hm.glossary[ss.sectiontype].prefmt;
ss.hm_field = hm.glossary[ss.sectiontype].field;
ss.hm_lowcase_only = false;
/* Import mihomo config start */
ss.handleYamlImport = function() {
const field = this.hm_field;
const o = new hm.HandleImport(this.map, this, _('Import mihomo config'),
_('Please type <code>%s</code> fields of mihomo config.</br>')
.format(field));
o.placeholder = 'rules:\n' +
'- DOMAIN,ad.com,REJECT\n' +
'- DOMAIN-REGEX,^abc.*com,auto\n' +
'- GEOSITE,youtube,PROXY\n' +
'- IP-CIDR,127.0.0.0/8,DIRECT,no-resolve\n' +
'- IP-SUFFIX,8.8.8.8/24,auto\n' +
'- IP-ASN,13335,DIRECT\n' +
'- GEOIP,CN,DIRECT\n' +
'- PROCESS-PATH,/usr/bin/wget,auto\n' +
'- PROCESS-PATH-REGEX,.*bin/wget,auto\n' +
'- PROCESS-NAME,curl,auto\n' +
'- PROCESS-NAME-REGEX,curl$,auto\n' +
'- UID,1001,DIRECT\n' +
'- NETWORK,udp,DIRECT\n' +
'- DSCP,4,DIRECT\n' +
'- RULE-SET,google,GLOBAL,no-resolve\n' +
'- AND,((DST-PORT,443),(NETWORK,udp)),REJECT\n' +
'- OR,((NETWORK,UDP),(DOMAIN,baidu.com)),DIRECT\n' +
'- NOT,((DOMAIN,baidu.com)),auto\n' +
'- SUB-RULE,(NETWORK,tcp),sub-rule1\n' +
'- SUB-RULE,(OR,((NETWORK,udp),(DOMAIN,google.com))),sub-rule2\n' +
'- AND,((GEOIP,cn),(DSCP,12),(NETWORK,udp),(NOT,((IP-ASN,12345))),(DSCP,14),(NOT,((NETWORK,udp)))),DIRECT\n' +
'- MATCH,GLOBAL\n' +
' ...'
o.parseYaml = function(field, name, cfg) {
let config = hm.HandleImport.prototype.parseYaml.call(this, field, name, cfg);
return config ? parseRulesYaml.call(this, field, name, config) : config;
};
return o.render();
}
ss.renderSectionAdd = function(/* ... */) {
let el = hm.GridSection.prototype.renderSectionAdd.apply(this, arguments);
el.appendChild(E('button', {
'class': 'cbi-button cbi-button-add',
'title': _('mihomo config'),
'click': ui.createHandlerFn(this, 'handleYamlImport')
}, [ _('Import mihomo config') ]));
return el;
}
/* Import mihomo config end */
so = ss.option(form.Value, 'label', _('Label'));
so.load = L.bind(hm.loadDefaultLabel, so);

View File

@ -12,7 +12,8 @@ export const PRESET_OUTBOUND = [
'REJECT',
'REJECT-DROP',
'PASS',
'COMPATIBLE'
'COMPATIBLE',
'GLOBAL'
];
export const RULES_LOGICAL_TYPE = [
'AND',

View File

@ -2,7 +2,7 @@
include $(TOPDIR)/rules.mk
PKG_VERSION:=1.0.0-20250207
PKG_VERSION:=1.0.0-20250313
PKG_RELEASE:=
LUCI_TITLE:=LuCI support for Immich

View File

@ -35,24 +35,35 @@ do_install() {
cd $config
export COMPOSE_PROJECT_NAME=linkease-immich
docker pull redis:6.2-alpine@sha256:905c4ee67b8e0aa955331960d2aa745781e6bd89afc44a8584bfd13bc890f0ae
RET=$?
if [ ! "$RET" = "0" ]; then
echo "download failed, install istoreenhance to speedup"
exit 1
fi
docker pull tensorchord/pgvecto-rs:pg14-v0.2.0@sha256:90724186f0a3517cf6914295b5ab410db9ce23190a2d9d0b9dd6463e3fa298f0
RET=$?
if [ ! "$RET" = "0" ]; then
echo "download failed"
echo "download failed, install istoreenhance to speedup"
exit 1
fi
docker pull "immich-app/immich-machine-learning:$IMMICH_VERSION"
docker pull "linkease/immich-machine-learning:$IMMICH_VERSION"
RET=$?
if [ ! "$RET" = "0" ]; then
echo "download failed"
echo "download failed, install istoreenhance to speedup"
exit 1
fi
docker pull "immich-app/immich-server:$IMMICH_VERSION"
docker pull "linkease/immich-server:$IMMICH_VERSION"
RET=$?
if [ ! "$RET" = "0" ]; then
echo "download failed"
echo "download failed, install istoreenhance to speedup"
exit 1
fi
docker-compose down || true
docker-compose up -d
}
@ -82,10 +93,10 @@ case ${ACTION} in
cd $config && docker-compose ${ACTION}
;;
"status")
docker ps --all -f 'name=^/linkease-immich_frontend_1$' --format '{{.State}}'
docker ps --all -f 'name=^/immich_server$' --format '{{.State}}'
;;
"port")
docker ps --all -f 'name=^/linkease-immich_frontend_1$' --format '{{.Ports}}' | grep -om1 '0.0.0.0:[0-9]*' | sed 's/0.0.0.0://'
docker ps --all -f 'name=^/immich_server$' --format '{{.Ports}}' | grep -om1 '0.0.0.0:[0-9]*' | sed 's/0.0.0.0://'
;;
*)
usage

View File

@ -11,14 +11,13 @@ name: immich
services:
immich-server:
container_name: immich_server
image: immich-app/immich-server:${IMMICH_VERSION:-release}
image: linkease/immich-server:${IMMICH_VERSION:-release}
# extends:
# file: hwaccel.transcoding.yml
# service: cpu # set to one of [nvenc, quicksync, rkmpp, vaapi, vaapi-wsl] for accelerated transcoding
volumes:
# Do not edit the next line. If you want to change the media storage location on your system, edit the value of UPLOAD_LOCATION in the .env file
- ${UPLOAD_LOCATION}:/usr/src/app/upload
- /etc/localtime:/etc/localtime:ro
env_file:
- .env
ports:
@ -34,7 +33,7 @@ services:
container_name: immich_machine_learning
# For hardware acceleration, add one of -[armnn, cuda, openvino] to the image tag.
# Example tag: ${IMMICH_VERSION:-release}-cuda
image: immich-app/immich-machine-learning:${IMMICH_VERSION:-release}
image: linkease/immich-machine-learning:${IMMICH_VERSION:-release}
# extends: # uncomment this section for hardware acceleration - see https://immich.app/docs/features/ml-hardware-acceleration
# file: hwaccel.ml.yml
# service: cpu # set to one of [armnn, cuda, openvino, openvino-wsl] for accelerated inference - use the `-wsl` version for WSL2 where applicable

View File

@ -1,6 +0,0 @@
config netdata 'netdata'
option logger '1'
option enabled '0'
option port '19990'

View File

@ -1,11 +0,0 @@
#!/bin/sh
[ -f /usr/share/netdata/webcn/netdata.conf ] && mv -f /usr/share/netdata/webcn/netdata.conf /etc/netdata/netdata.conf
[ -f /usr/share/netdata/webcn/netdata ] && mv -f /usr/share/netdata/webcn/netdata /etc/config/netdata
[ -f /usr/share/netdata/webcn/dashboard.js ] && mv -f /usr/share/netdata/webcn/dashboard.js /usr/share/netdata/web/dashboard.js
[ -f /usr/share/netdata/webcn/dashboard_info.js ] && mv -f /usr/share/netdata/webcn/dashboard_info.js /usr/share/netdata/web/dashboard_info.js
[ -f /usr/share/netdata/webcn/main.js ] && mv -f /usr/share/netdata/webcn/main.js /usr/share/netdata/web/main.js
[ -f /usr/share/netdata/webcn/index.html ] && mv -f /usr/share/netdata/webcn/index.html /usr/share/netdata/web/index.html
[ -f /usr/share/netdata/webcn/netdata.init ] && mv -f /usr/share/netdata/webcn/netdata.init /etc/init.d/netdata
rm -rf /tmp/luci-modulecache /tmp/luci-indexcache*
chmod +x /etc/init.d/netdata
exit 0